/**
 * 
 */
package net.bigeon.gclc.process;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

import net.bigeon.gclc.process.mocks.TaskMock;

/**
 * @author Emmanuel Bigeon
 *
 */
public class ProcessClearTest {

    /**
     * Test method for {@link net.bigeon.gclc.process.ProcessClear#ProcessClear(java.lang.String, net.bigeon.gclc.process.TaskPool)}.
     */
    @Test
    public void testProcessClear() {
        final ProcessClear pl = new ProcessClear("clear", new TaskPool());
        assertEquals("Command name should be kept as specified", "clear",
                pl.getCommandName());
    }

    /**
     * Test method for {@link net.bigeon.gclc.process.ProcessClear#execute(net.bigeon.gclc.manager.ConsoleOutput, net.bigeon.gclc.manager.ConsoleInput, java.lang.String[])}.
     */
    @Test
    public void testExecute() {
        final TaskPool pool = new TaskPool();
        final TaskMock task = new TaskMock();
        pool.add(task);
        final ProcessClear pl = new ProcessClear("clear", pool);
        pl.execute(null, null);
        assertTrue("cleared pool should be empty", pool.getPIDs().isEmpty());
    }

    /**
     * Test method for {@link net.bigeon.gclc.process.ProcessClear#tip()}.
     */
    @Test
    public void testTip() {
        final ProcessClear pl = new ProcessClear("clear", new TaskPool());
        assertNotNull("Command tip should be defined", pl.tip());
        assertNotNull("Command usage should be defined", pl.usageDetail());
    }

}
