package net.bigeon.gclc.socket;

/*-
 * #%L
 * GCLC Socket
 * %%
 * Copyright (C) 2016 - 2018 Bigeon
 * %%
 * This software is governed by the CeCILL  license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 * #L%
 */
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.ArrayList;
import java.util.Collection;

import net.bigeon.smu.StringEncoder;

/** TODO Describe TestConsoleClient.java
 * 
 * @author Emmanuel Bigeon */
@SuppressWarnings("nls")
public class TestConsoleClient {
    @SuppressWarnings("javadoc")
    private static final Collection<String> TO_ENCODE = new ArrayList<>();
    static {
        TO_ENCODE.add("\n");
    }

    @SuppressWarnings("javadoc")
    private static final StringEncoder ENCODER = new StringEncoder("%", TO_ENCODE);

    @SuppressWarnings("javadoc")
    public static void main(String[] args) {
        final String hostName = "127.0.0.1";
        final int portNumber = 3300;

        try (Socket kkSocket = new Socket(hostName, portNumber);
                PrintWriter out = new PrintWriter(kkSocket.getOutputStream(), true);
                BufferedReader in = new BufferedReader(
                        new InputStreamReader(kkSocket.getInputStream()));) {

            String fromServer;
            while ((fromServer = in.readLine()) != null) {
                System.out.println("Server: \n" + ENCODER.decode(fromServer));
                if (fromServer.equals("Bye.")) {
                    break;
                }

                final BufferedReader stdIn = new BufferedReader(
                        new InputStreamReader(System.in));
                final String fromUser = stdIn.readLine();
                if (fromUser != null) {
                    System.out.println("Client: " + fromUser);
                    out.println(fromUser);
                }
            }
        } catch (final IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

    }
}
